diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.module b/drupal7/sites/all/modules/webform_validation/webform_validation.module
index 15f3cebb..c6688b65 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.module
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.module
@@ -76,11 +76,8 @@ function webform_validation_theme() {
         'nid' => NULL,
       ),
     ),
-    'webform_validation_manage_overview' => array(
-      'variables' => array(
-        'rules' => NULL,
-        'node' => NULL,
-      ),
+    'webform_validation_manage_overview_form' => array(
+      'render element' => 'form',
     ),
   );
 }
@@ -94,6 +91,21 @@ function webform_validation_form_alter(&$form, &$form_state, $form_id) {
   }
 }
 
+/**
+ * Implements hook_i18n_string_info().
+ */
+function webform_validation_i18n_string_info() {
+  $groups = array();
+  $groups['webform_validation'] = array(
+    'title' => t('Webform Validation'),
+    'description' => t('Translatable strings for webform validation translation'),
+    'format' => FALSE, // This group doesn't have strings with format
+    'list' => FALSE, // This group cannot list all strings
+    'refresh callback' => 'webform_validation_i18n_string_refresh',
+  );
+  return $groups;
+}
+
 /**
  * Webform validation handler to validate against the given rules
  */
@@ -145,7 +157,7 @@ function webform_validation_validate($form, &$form_state) {
       // create a list of components that need validation against this rule (component id => user submitted value)
       $items = array();
       foreach ($rule['components'] as $cid => $component) {
-        if (isset($flat_values[$cid])) {
+        if (array_key_exists($cid, $flat_values)) {
           $items[$cid] = $flat_values[$cid];
         }
       }
@@ -161,7 +173,15 @@ function webform_validation_validate($form, &$form_state) {
         foreach ($errors as $item_key => $error) {
           // build the proper form element error key, taking into account hierarchy
           $error_key = 'submitted][' . webform_validation_parent_tree($item_key, $components) . $components[$item_key]['form_key'];
-          form_set_error($error_key, $error);
+          if (is_array($error)) {
+            foreach ($error as $sub_item_key => $sub_error) {
+              form_set_error($error_key . '][' . $sub_item_key, $sub_error);
+            }
+          }
+          else {
+            // @ignore security_form_set_error. filter_xss() is run in _webform_validation_i18n_error_message().
+            form_set_error($error_key, $error);
+          }
         }
       }
     }
@@ -248,18 +268,28 @@ function theme_webform_validation_manage_add_rule($variables) {
   $validators = webform_validation_get_validators();
 
   if ($validators) {
+    $results = db_query('SELECT DISTINCT type FROM {webform_component} WHERE nid = :nid', array('nid' => $nid));
+    $types = array();
+    while ($item = $results->fetch()) {
+      $types[] = $item->type;
+    }
+
     $output = '<h3>' . t('Add a validation rule') . '</h3>';
     $output .= '<dl>';
     foreach ($validators as $validator_key => $validator_info) {
-      $item = '';
       $url = 'node/' . $nid . '/webform/validation/add/' . $validator_key;
-      $components = ' (' . implode(', ', $validator_info['component_types']) . ')';
-      $item = '<dt>' . l($validator_info['name'], $url, array("query" => drupal_get_destination())) . '</dt>';
-      $item .= '<dd>';
-      if ($validator_info['description']) {
-        $item .= $validator_info['description'] . ' ';
+      if (array_intersect($types, $validator_info['component_types'])) {
+        $title = l($validator_info['name'], $url, array('query' => drupal_get_destination()));
+        $component_list_postfix = '';
+      }
+      else {
+        $title = $validator_info['name'];
+        $component_list_postfix = '; none present in this form';
       }
-      $item .= $components . '</dd>';
+      $item = '<dt>' . $title . '</dt>';
+      $item .= '<dd>';
+      $item .= $validator_info['description'];
+      $item .= ' Works with: ' . implode(', ', $validator_info['component_types']) . $component_list_postfix . '.</dd>';
       $output .= $item;
     }
     $output .= '</dl>';
@@ -272,8 +302,8 @@ function theme_webform_validation_manage_add_rule($variables) {
  */
 function webform_validation_webform_validation($type, $op, $data) {
   if ($type == 'rule' && in_array($op, array('add', 'edit'))) {
-    if (module_exists('i18nstrings') && isset($data['error_message'])) {
-      i18nstrings_update('webform_validation:error_message:' . $data['ruleid'] . ':message', $data['error_message']);
+    if (module_exists('i18n') && isset($data['error_message'])) {
+      i18n_string_update('webform_validation:error_message:' . $data['ruleid'] . ':message', $data['error_message']);
     }
   }
 }
@@ -322,46 +352,76 @@ function webform_validation_node_clone($node) {
 }
 
 /**
- * Save a validation rule. Data comes from the admin form
- * or nodeapi function in case of node clone
+ * Save a validation rule. Data comes from the admin form or nodeapi function in
+ * case of node clone.
+ *
+ * @param array $values
+ *   An associative array containing:
+ *   - action: "add" or "edit".
+ *   - ruleid: ID of the rule to edit. Do not set for "add".
+ *   - nid: Node ID of the Webform.
+ *   - validator: Machine name of the validator used by this validation rule.
+ *   - rulename: Human-readable name for this validation rule.
+ *   - rule_components: An array in which the keys and the values are the cid's
+ *     of the Webform components that this rule applies to.
+ *
+ * @return int
+ *   The $ruleid of the rule added or edited.
  */
 function webform_validation_rule_save($values) {
-  // save rules data
-  if ($values['action'] == 'add') {
-    drupal_write_record('webform_validation_rule', $values);
-    $ruleid = $values['ruleid'];
-    if ($ruleid && array_filter($values['rule_components'])) {
-      webform_validation_save_rule_components($ruleid, array_filter($values['rule_components']));
-      module_invoke_all('webform_validation', 'rule', 'add', $values);
-    }
+  if ($values['action'] === 'add') {
+    $primary_keys = array();
+  }
+  elseif ($values['action'] === 'edit') {
+    $primary_keys = array('ruleid');
   }
+  else {
+    return FALSE;
+  }
+
+  drupal_write_record('webform_validation_rule', $values, $primary_keys);
 
-  if ($values['action'] == 'edit') {
-    drupal_write_record('webform_validation_rule', $values, 'ruleid');
-    $ruleid = $values['ruleid'];
-    // delete earlier component records for this rule id*/
+  // Delete existing component records for this ruleid.
+  if ($values['action'] === 'edit') {
     db_delete('webform_validation_rule_components')
-    ->condition('ruleid', $ruleid)
-    ->execute();
-    if ($components = array_filter($values['rule_components'])) {
-      webform_validation_save_rule_components($ruleid, $components);
-      module_invoke_all('webform_validation', 'rule', 'edit', $values);
-    }
+      ->condition('ruleid', $values['ruleid'])
+      ->execute();
   }
+
+  $components = array_filter($values['rule_components']);
+  if ($values['ruleid'] && $components) {
+    webform_validation_save_rule_components($values['ruleid'], $components);
+    module_invoke_all('webform_validation', 'rule', $values['action'], $values);
+  }
+
+  return $values['ruleid'];
 }
 
 /**
- * Save components attached to a specific rule
+ * Save components attached to a specific rule.
+ *
+ * @param int $ruleid
+ *   The ruleid of the rule being saved.
+ * @param array $components
+ *   An array in which the keys are the cid's of the components attached to the rule.
+ * @return array
+ *   An array of the return statuses for each query keyed by cid.
  */
 function webform_validation_save_rule_components($ruleid, $components) {
+  $return_status = array();
   foreach ($components as $cid => $component) {
-    $id = db_insert('webform_validation_rule_components')
-    ->fields(array(
-      'ruleid' => $ruleid,
-      'cid' => $cid,
-    ))
-  ->execute();
+    $return_status[$cid] = db_merge('webform_validation_rule_components')
+      ->key(array(
+        'ruleid' => $ruleid,
+        'cid' => $cid,
+      ))
+      ->fields(array(
+        'ruleid' => $ruleid,
+        'cid' => $cid,
+      ))
+      ->execute();
   }
+  return $return_status;
 }
 
 /**
@@ -404,6 +464,7 @@ function webform_validation_webform_validator_alter(&$validators) {
         if (in_array('textfield', $validator_info['component_types'])) {
           $validators[$validator_name]['component_types'][] = 'select';
         }
+        $validators[$validator_name]['component_types'] = array_unique($validators[$validator_name]['component_types']);
       }
     }
   }
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.rules.inc b/drupal7/sites/all/modules/webform_validation/webform_validation.rules.inc
index 19c1c24f..d3e2fc99 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.rules.inc
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.rules.inc
@@ -9,7 +9,7 @@
  * Get a rule entry
  */
 function webform_validation_get_rule($ruleid) {
-  $result = db_query("SELECT ruleid, rulename, nid, validator, data, error_message, negate FROM {webform_validation_rule} WHERE ruleid = :ruleid", array(':ruleid' => $ruleid), array('fetch' => PDO::FETCH_ASSOC));
+  $result = db_query("SELECT ruleid, rulename, nid, validator, data, error_message, negate, weight FROM {webform_validation_rule} WHERE ruleid = :ruleid", array(':ruleid' => $ruleid), array('fetch' => PDO::FETCH_ASSOC));
   $rule = $result->fetchAssoc();
   $rule['components'] = webform_validation_get_rule_components($ruleid, $rule['nid']);
   $rule['negate'] = (bool) $rule['negate'];
@@ -21,7 +21,7 @@ function webform_validation_get_rule($ruleid) {
  */
 function webform_validation_get_node_rules($nid) {
   $rules = array();
-  $result = db_query("SELECT ruleid, rulename, nid, validator, data, error_message, negate FROM {webform_validation_rule} WHERE nid = :nid ORDER BY ruleid DESC", array(':nid' => $nid), array('fetch' => PDO::FETCH_ASSOC));
+  $result = db_query("SELECT ruleid, rulename, nid, validator, data, error_message, negate, weight FROM {webform_validation_rule} WHERE nid = :nid ORDER BY weight ASC, ruleid DESC", array(':nid' => $nid), array('fetch' => PDO::FETCH_ASSOC));
   foreach ($result as $rule) {
     $rule['components'] = webform_validation_get_rule_components($rule['ruleid'], $rule['nid']);
     $rule['negate'] = (bool) $rule['negate'];
@@ -79,15 +79,18 @@ function webform_validation_rule_components_basic($components) {
 }
 
 /**
- * Delete a rule and dependencies
+ * Delete a rule and dependencies.
+ *
+ * @param int $ruleid
+ *   The ruleid of the rule to delete.
  */
 function webform_dynamic_delete_rule($ruleid) {
-  // delete rule
+  // Delete rule.
   db_delete('webform_validation_rule')
-  ->condition('ruleid', $ruleid)
-  ->execute();
-  // delete rule components
+    ->condition('ruleid', $ruleid)
+    ->execute();
+  // Delete rule components.
   db_delete('webform_validation_rule_components')
-  ->condition('ruleid', $ruleid)
-  ->execute();
+    ->condition('ruleid', $ruleid)
+    ->execute();
 }
